Index: code/trunk/src/libraries/core/SmartPtr.h
===================================================================
--- code/trunk/src/libraries/core/SmartPtr.h	(revision 7380)
+++ code/trunk/src/libraries/core/SmartPtr.h	(revision 7401)
@@ -29,4 +29,91 @@
 // Inspired by boost::intrusive_ptr by Peter Dimov
 
+/**
+    @defgroup SmartPtr SmartPtr<T> and WeakPtr<T>
+    @ingroup Object
+*/
+
+/**
+    @file
+    @ingroup Object SmartPtr
+    @brief Definition of SmartPtr<T>, wraps a pointer to an object and keeps it alive.
+
+    @anchor SmartPtrExample
+
+    orxonox::SmartPtr is an implementation of a smart pointer - it wraps a pointer to an
+    object  and keeps this object alive until no SmartPtr points to this object anymore.
+    In contrast to orxonox::SharedPtr, SmartPtr works only with classes that are derived
+    from orxonox::OrxonoxClass, because it's an intrusive implementation, meaning the
+    reference counter is stored in the object itself.
+
+    It's possible to use normal pointers and smart pointers to an object simultaneously.
+    You don't have to use SmartPtr all the time, you can create a SmartPtr for an object
+    at any time and also convert it back to a normal pointer if you like. This is possible
+    because the reference counter is stored in the object itself and not in SmartPtr (in
+    contrast to SharedPtr).
+
+    @b Important: If you want to delete an object, you must not use @c delete @c object but
+    rather @c object->destroy(). This function will check if there are smart pointers
+    pointing to the object. If yes, the object will be kept alive until all smart pointes
+    are destroyed. If no, the object is deleted instantly.
+
+    If all smart pointers that point to an object are destroyed, but you never called
+    @c object->destroy() before, the object will not be deleted! All a SmartPtr will do
+    is to really just keep an object alive, but it will not delete it automatically
+    unless you tried to destroy it before.
+
+    Example:
+    @code
+    class MyClass                                           // class declaration
+    {
+        public:
+            void setObject(OtherClass* object)              // passes a normal pointer which will be stored in a SmartPtr
+                { this->object_ = object; }
+
+            OtherClass* getObject() const                   // converts the SmartPtr to a normal pointer and returns it
+                { return this->object_; }
+
+        private:
+            SmartPtr<OtherClass> object_;                   // a pointer to an instance of OtherClass is stored in a SmartPtr
+    };
+    @endcode
+    In this example we assume that OtherClass is a child of OrxonoxClass. We don't care
+    about the inheritance of MyClass though.
+
+    Now we create an instance of MyClass and assign a pointer to an instance of OtherClass:
+    @code
+    MyClass* myclass = new MyClass();                       // create an instance of MyClass
+    OtherClass* object = new OtherClass();                  // create an instance of OtherClass
+    myclass->setObject(object);                             // the object is now stored in a SmartPtr inside myclass
+
+    object->destroy();                                      // we try to destroy object, but there's still a SmartPtr pointing at it.
+
+    # object still exists at this point (because a SmartPtr points at it)
+
+    delete myclass;                                         // now we delete myclass, which also destroys the SmartPtr
+
+    # object doesn't exist anymore (because the SmartPtr is now destroyed)
+    @endcode
+
+    Now we look at the same example, but we first delete myclass, then destroy object:
+    @code
+    MyClass* myclass = new MyClass();                       // create an instance of MyClass
+    OtherClass* object = new OtherClass();                  // create an instance of OtherClass
+    myclass->setObject(object);                             // the object is now stored in a SmartPtr inside myclass
+
+    delete myclass;                                         // we delete myclass, which also destroys the SmartPtr
+
+    # object still exists at this point (because destroy() was not called yet)
+
+    object->destroy();                                      // now we try to destroy object, which works instantly
+
+    # object doesn't exist anymore (because we just destroyed it)
+    @endcode
+
+    Note that in any case @c object->destroy() has to be called to delete the object.
+    However if a SmartPtr points at it, the destruction is delayed until all SmartPtr
+    are destroyed.
+*/
+
 #ifndef _SmartPtr_H__
 #define _SmartPtr_H__
@@ -42,16 +129,24 @@
 namespace orxonox
 {
+    /**
+        @brief A smart pointer which wraps a pointer to an object and keeps this object alive as long as the smart pointer exists.
+
+        @see See @ref SmartPtrExample "this description" for more information and an example.
+    */
     template <class T>
     class SmartPtr
     {
         public:
+            /// Constructor: Initializes the smart pointer with a null pointer.
             inline SmartPtr() : pointer_(0), base_(0)
             {
             }
 
+            /// Constructor: Used to explicitly initialize the smart pointer with a null pointer
             inline SmartPtr(int) : pointer_(0), base_(0)
             {
             }
 
+            /// Constructor: Initializes the smart pointer with a pointer to an object. @param pointer The pointer @param bAddRef If true, the reference counter is increased. Don't set this to false unless you know exactly what you're doing! (for example to avoid circular references if the @c this pointer of the possessing object is stored)
             inline SmartPtr(T* pointer, bool bAddRef = true) : pointer_(pointer), base_(pointer)
             {
@@ -60,4 +155,5 @@
             }
 
+            /// Copy-constructor
             inline SmartPtr(const SmartPtr& other) : pointer_(other.pointer_), base_(other.base_)
             {
@@ -66,4 +162,5 @@
             }
 
+            /// Copy-constructor for smart pointers to objects of another class.
             template <class O>
             inline SmartPtr(const SmartPtr<O>& other) : pointer_(other.get()), base_(other.base_)
@@ -73,4 +170,5 @@
             }
 
+            /// Constructor: Initializes the smart pointer with the pointer that is stored in a WeakPtr.
             template <class O>
             inline SmartPtr(const WeakPtr<O>& other) : pointer_(other.get()), base_(other.getBase())
@@ -80,4 +178,5 @@
             }
 
+            /// Destructor: Decrements the reference counter.
             inline ~SmartPtr()
             {
@@ -86,4 +185,5 @@
             }
 
+            /// Used to assign a null pointer.
             inline SmartPtr& operator=(int)
             {
@@ -92,4 +192,5 @@
             }
 
+            /// Assigns a new pointer.
             inline SmartPtr& operator=(T* pointer)
             {
@@ -98,4 +199,5 @@
             }
 
+            /// Assigns the wrapped pointer of another SmartPtr.
             inline SmartPtr& operator=(const SmartPtr& other)
             {
@@ -104,4 +206,5 @@
             }
 
+            /// Assigns the wrapped pointer of a SmartPtr of another class
             template <class O>
             inline SmartPtr& operator=(const SmartPtr<O>& other)
@@ -111,4 +214,5 @@
             }
 
+            /// Assigns the wrapped pointer of a WeakPtr.
             template <class O>
             inline SmartPtr& operator=(const WeakPtr<O>& other)
@@ -118,4 +222,5 @@
             }
 
+            /// Returns the wrapped pointer as @c T*
             inline T* get() const
             {
@@ -123,4 +228,5 @@
             }
 
+            /// Returns the wrapped pointer as @c OrxonoxClass*
             inline OrxonoxClass* getBase() const
             {
@@ -128,4 +234,5 @@
             }
 
+            /// Implicitly converts the SmartPtr to a pointer of type @c T*
             inline operator T*() const
             {
@@ -133,4 +240,5 @@
             }
 
+            /// Overloaded operator, returns a pointer to the stored object.
             inline T* operator->() const
             {
@@ -139,4 +247,5 @@
             }
 
+            /// Overloaded operator, returns a reference to the stored object.
             inline T& operator*() const
             {
@@ -145,4 +254,5 @@
             }
 
+            /// Returns true if the wrapped pointer is NULL.
             inline bool operator!() const
             {
@@ -150,4 +260,5 @@
             }
 
+            /// Swaps the contents of two smart pointers.
             inline void swap(SmartPtr& other)
             {
@@ -164,4 +275,5 @@
             }
 
+            /// Resets the smart pointer (equivalent to assigning a NULL pointer).
             inline void reset()
             {
@@ -170,8 +282,9 @@
 
         private:
-            T* pointer_;
-            OrxonoxClass* base_;
+            T* pointer_;            ///< The wrapped pointer to an object of type @a T
+            OrxonoxClass* base_;    ///< The wrapped pointer, casted up to OrxonoxClass (this is needed because with just a T* pointer, SmartPtr couln't be used with forward declarations)
     };
 
+    /// Swaps the contents of two smart pointers.
     template <class T>
     void swap(SmartPtr<T>& a, SmartPtr<T>& b)
@@ -180,4 +293,5 @@
     }
 
+    /// Uses a static_cast to cast a pointer of type U* to a pointer of type T* and returns it in a new SmartPtr<T>.
     template <class T, class U>
     SmartPtr<T> static_pointer_cast(const SmartPtr<U>& p)
@@ -186,4 +300,5 @@
     }
 
+    /// Uses a const_cast to cast a pointer of type U* to a pointer of type T* and returns it in a new SmartPtr<T>.
     template <class T, class U>
     SmartPtr<T> const_pointer_cast(const SmartPtr<U>& p)
@@ -192,4 +307,5 @@
     }
 
+    /// Uses a dynamic_cast to cast a pointer of type U* to a pointer of type T* and returns it in a new SmartPtr<T>.
     template <class T, class U>
     SmartPtr<T> dynamic_pointer_cast(const SmartPtr<U>& p)
Index: code/trunk/src/libraries/core/SubclassIdentifier.h
===================================================================
--- code/trunk/src/libraries/core/SubclassIdentifier.h	(revision 7380)
+++ code/trunk/src/libraries/core/SubclassIdentifier.h	(revision 7401)
@@ -29,8 +29,36 @@
 /**
     @file
+    @ingroup Class Identifier
     @brief Definition of SubclassIdentifier.
+
+    @anchor SubclassIdentifierExample
 
     SubclassIdentifier is a separated class, acting like an Identifier, but has a given class.
     You can only assign Identifiers of exactly the given class or of a derivative to a SubclassIdentifier.
+
+    Example:
+
+    You can assign an Identifier either through the constructor or by using the assignment @c operator=:
+    @code
+    SubclassIdentifier<BaseClass> identifier = Class(SubClass);
+    @endcode
+
+    The @c operator-> is overloaded an returns the assigned Identifier. That way you can just call
+    functions of the assigned Identifier by using @c ->function():
+    @code
+    SubclassIdentifier<BaseClass> identifier = Class(SubClass);
+    identifier->getName();      // returns "SubClass"
+    @endcode
+
+    There are two possibilities to create an object out of a SubclassIdentifier: Either you just use
+    the @c fabricate() function of the assigned Identifier through the overloaded @c operator->, which
+    returns a @c BaseObject* pointer, or you use the function of SubclassIdentifier, this time by using
+    @c operator., which returns a @c BaseClass* pointer (@a BaseClass is the baseclass specified by the
+    template argument):
+    @code
+    identifier->fabricate();    // calls Identifier::fabricate(), creates a SubClass, returns a BaseObject* pointer
+
+    identifier.fabricate();     // calls SubclassIdentifier::fabricate(), creates a SubClass, returns a BaseClass* pointer
+    @endcode
 */
 
@@ -49,9 +77,13 @@
     // ###   SubclassIdentifier    ###
     // ###############################
-    //! The SubclassIdentifier acts almost like an Identifier, but has some prerequisites.
     /**
+        @brief The SubclassIdentifier acts almost like an Identifier, but has some prerequisites.
+
         You can only assign an Identifier that belongs to a class T (or derived) to a SubclassIdentifier<T>.
-        If you assign something else, the program aborts.
-        Because we know the minimum type, a dynamic_cast is done, which makes it easier to create a new object.
+        If you assign something else, the program prints an error.
+
+        Because we know the base-type, a @c dynamic_cast is done, which makes it easier to create a new object.
+
+        @see See @ref SubclassIdentifierExample "SubclassIdentifier.h" for some examples.
     */
     template <class T>
@@ -59,7 +91,5 @@
     {
         public:
-            /**
-                @brief Constructor: Automaticaly assigns the Identifier of the given class.
-            */
+            /// Constructor: Automaticaly assigns the Identifier of the given class.
             SubclassIdentifier()
             {
@@ -67,8 +97,5 @@
             }
 
-            /**
-                @brief Constructor: Assigns the given Identifier.
-                @param identifier The Identifier
-            */
+            /// Constructor: Assigns the given Identifier.
             SubclassIdentifier(Identifier* identifier)
             {
@@ -76,8 +103,5 @@
             }
 
-            /**
-                @brief Copyconstructor: Assigns the identifier of the other SubclassIdentifier.
-                @param identifier The other SublcassIdentifier
-            */
+            /// Copyconstructor: Assigns the identifier of another SubclassIdentifier.
             template <class O>
             SubclassIdentifier(const SubclassIdentifier<O>& identifier)
@@ -113,8 +137,5 @@
             }
 
-            /**
-                @brief Overloading of the = operator: assigns the identifier of the other SubclassIdentifier.
-                @param identifier The other SublcassIdentifier
-            */
+            /// Overloading of the = operator: assigns the identifier of another SubclassIdentifier.
             template <class O>
             SubclassIdentifier<T>& operator=(const SubclassIdentifier<O>& identifier)
@@ -123,7 +144,5 @@
             }
 
-            /**
-                @brief Overloading of the * operator: returns the assigned identifier.
-            */
+            /// Overloading of the * operator: returns the assigned identifier.
             inline Identifier* operator*() const
             {
@@ -131,7 +150,5 @@
             }
 
-            /**
-                @brief Overloading of the -> operator: returns the assigned identifier.
-            */
+            /// Overloading of the -> operator: returns the assigned identifier.
             inline Identifier* operator->() const
             {
@@ -139,7 +156,5 @@
             }
 
-            /**
-                @brief Returns the assigned identifier. This allows you to assign a SubclassIdentifier to a normal Identifier*.
-            */
+            /// Returns the assigned identifier. This allows you to assign a SubclassIdentifier to a normal Identifier*.
             inline operator Identifier*() const
             {
@@ -147,8 +162,5 @@
             }
 
-            /**
-                @brief Creates a new object of the type of the assigned Identifier and dynamic_casts it to the minimal type given by T.
-                @return The new object
-            */
+            /// Creates a new object of the type of the assigned Identifier and dynamic_casts it to the minimal type given by T.
             T* fabricate(BaseObject* creator) const
             {
@@ -181,5 +193,5 @@
             }
 
-            /** @brief Returns the assigned identifier. @return The identifier */
+            /// Returns the assigned identifier.
             inline Identifier* getIdentifier() const
                 { return this->identifier_; }
Index: code/trunk/src/libraries/core/Super.h
===================================================================
--- code/trunk/src/libraries/core/Super.h	(revision 7380)
+++ code/trunk/src/libraries/core/Super.h	(revision 7401)
@@ -28,37 +28,42 @@
 
 /**
+    @defgroup Super Super
+    @ingroup Class
+*/
+
+/**
     @file
-    @brief Definition of all super-function related macros.
-
-    This file defines all macros needed to add a new "super-function".
-    If you add a super-function, you can call SUPER(myclass, functionname) inside your
-    code and the function of the parentclass gets called. This is comparable with
-    super.functionname() in Java or other languages.
-
-    This works only with virtual functions that return nothing (void) and belong to
-    classes that have an Identifier. Arguments however are supported.
-
-    To add a new super-function, you have process 4 steps:
-
-    1) Add a new SUPER macro
-       This allows you to call the super-function in your code.
-       Location: This file (Super.h), marked with --> HERE <-- comments (1/3)
-
-    2) Call the SUPER_FUNCTION_GLOBAL_DECLARATION_PART1/2 macros.
-       This defines some global classes and templates, needed to create and call the super-functions.
-       Location: This file (Super.h), marked with --> HERE <-- comments (2/3)
-
-    3) Call the SUPER_INTRUSIVE_DECLARATION macro.
-       This will be included into the declaration of ClassIdentifier<T>.
-       Location: This file (Super.h), marked with --> HERE <-- comments (3/3)
-
-    4) Call the SUPER_FUNCTION macro.
+    @ingroup Class Super
+    @brief Definition of all super-function related macros, used to call functions of the base class.
+
+    This file defines all macros needed to add a new "super-function". If you add
+    a super-function, you can call <tt>SUPER(myclass, functionname, arguments)</tt>
+    inside your code and the function of the parent-class gets called. This is comparable
+    to <tt>super.functionname(arguments)</tt> in Java or other languages.
+
+    This works only with virtual functions that return nothing (@c void) and belong to
+    classes that have an @ref orxonox::Identifier "Identifier". Arguments however are
+    supported, there's no limitation for their number and type, except that the type has
+    to be known in Super.h.
+
+    To add a new super-function, you have to process 4 steps:
+
+    -# Add a new @c SUPER macro <br />
+       This allows you to call the super-function in your code. <br />
+       Location: This file (Super.h), marked with "--> HERE <--" comments (1/3)
+    -# Call the @c SUPER_FUNCTION_GLOBAL_DECLARATION_PART1/2 macros. <br />
+       This defines some global classes and templates, needed to create and call the super-functions. <br />
+       Location: This file (Super.h), marked with "--> HERE <--" comments (2/3)
+    -# Call the @c SUPER_INTRUSIVE_DECLARATION macro. <br />
+       This will be included into the declaration of @c ClassIdentifier<T>. <br />
+       Location: This file (Super.h), marked with "--> HERE <--" comments (3/3)
+    -# Call the @c SUPER_FUNCTION macro. <br />
        This defines a partially specialized template that will decide if a class is "super" to another class.
-       If the check returns true, a SuperFunctionCaller gets created, which will be used by the SUPER macro.
+       If the check returns true, a @c SuperFunctionCaller gets created, which will be used by the @c SUPER macro.
        You have to add this into the header-file of the baseclass of the super-function (the class that first
        implements the function), below the class declaration. You can't call it directly in this file, because
-       otherwise you had to include the headerfile right here, which would cause some ugly backdependencies,
-       include loops and slower compilation.
-       Dont forget to include Super.h in the header-file.
+       otherwise you had to include the headerfile right here, which would cause some ugly back-dependencies,
+       include loops and slower compilation. <br />
+       Dont forget to include Super.h in the header-file. <br />
        Location: The header-file of the baseclass (Baseclass.h), below the class declaration
 */
@@ -205,5 +210,5 @@
     */
 
-    // SUPER-macro: Calls Parent::functionname() where Parent is the direct parent of classname
+    /// SUPER-macro: Calls Parent::functionname(...) where Parent is the direct parent of @a classname
     #ifdef ORXONOX_COMPILER_MSVC
         #define SUPER(classname, functionname, ...) \
Index: code/trunk/src/libraries/core/Template.h
===================================================================
--- code/trunk/src/libraries/core/Template.h	(revision 7380)
+++ code/trunk/src/libraries/core/Template.h	(revision 7401)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup Template Template
+    @ingroup XML
+*/
+
+/**
+    @file
+    @ingroup XML Template
+*/
 
 #ifndef _Template_H__
Index: code/trunk/src/libraries/core/Thread.h
===================================================================
--- code/trunk/src/libraries/core/Thread.h	(revision 7380)
+++ code/trunk/src/libraries/core/Thread.h	(revision 7401)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup ThreadPool
+*/
 
 #ifndef _Thread_H__
Index: code/trunk/src/libraries/core/ThreadPool.h
===================================================================
--- code/trunk/src/libraries/core/ThreadPool.h	(revision 7380)
+++ code/trunk/src/libraries/core/ThreadPool.h	(revision 7401)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup ThreadPool Thread pool
+    @ingroup Core
+*/
+
+/**
+    @file
+    @ingroup ThreadPool
+*/
 
 #ifndef _ThreadPool_H__
Index: code/trunk/src/libraries/core/ToluaInterface.h
===================================================================
--- code/trunk/src/libraries/core/ToluaInterface.h	(revision 7380)
+++ code/trunk/src/libraries/core/ToluaInterface.h	(revision 7401)
@@ -29,4 +29,6 @@
 /**
 @file
+@ingroup Lua
+@brief
     This is required because tolua would parse this macro in LuaState.h and fail
 */
Index: code/trunk/src/libraries/core/WeakPtr.h
===================================================================
--- code/trunk/src/libraries/core/WeakPtr.h	(revision 7380)
+++ code/trunk/src/libraries/core/WeakPtr.h	(revision 7401)
@@ -29,4 +29,53 @@
 // Inspired by boost::intrusive_ptr by Peter Dimov
 
+/**
+    @file
+    @ingroup Object SmartPtr
+    @brief Definition of WeakPtr<T>, wraps a pointer to an object.
+
+    @anchor WeakPtrExample
+
+    A WeakPtr wraps a pointer to an object. If the object gets deleted, the WeakPtr becomes
+    NULL. This can be used to store pointers to objects without knowing when they will be
+    destroyed.
+
+    WeakPtr works only with objects that are derived from orxonox::OrxonoxClass, because
+    WeakPtr is intrusive and registers itself in the stored object, to get a notification if
+    the object is being deleted.
+
+    Example:
+    @code
+    MyClass* object = new MyClass();                    // create an instance of MyClass
+
+    WeakPtr<MyClass> pointer = object;                  // create a WeakPtr and assign the object
+
+    if (pointer)                                        // checks if pointer is not NULL (which is true)
+        pointer->someFunction();                        // calls MyClass::someFunction()
+
+    object->destroy();                                  // calls destroy() which deletes the object
+
+    if (pointer)                                        // checks if pointer is not NULL (which is now false)
+        pointer->someFunction();                        // this will not be executed
+    @endcode
+    In this example we assumed that MyClass is derived of OrxonoxClass (otherwise it couldn't
+    be used with a WeakPtr).
+
+    A callback can be registerd with the WeakPtr that will be called if the object gets deleted.
+    @code
+    void myCallback()                                   // definition of the callback function
+    {
+        COUT(0) << "Object destroyed" << std::endl;
+    }
+
+    MyClass* object = new MyClass();                    // create an instance of MyClass
+
+    WeakPtr<MyClass> pointer = object;                  // create a WeakPtr and assign the object
+
+    pointer.setCallback(createFunctor(&myCallback));    // defines a callback
+
+    object->destroy();                                  // calls destroy() which deletes the object. prints "Object destroyed" to the console
+    @endcode
+*/
+
 #ifndef _WeakPtr_H__
 #define _WeakPtr_H__
@@ -41,4 +90,9 @@
 namespace orxonox
 {
+    /**
+        @brief WeakPtr wraps a pointer to an object, which becomes NULL if the object is deleted.
+
+        @see See @ref WeakPtrExample "this description" for more information and an example.
+    */
     template <class T>
     class WeakPtr
@@ -47,12 +101,15 @@
 
         public:
+            /// Constructor: Initializes the weak pointer with a null pointer.
             inline WeakPtr() : pointer_(0), base_(0), callback_(0)
             {
             }
 
+            /// Constructor: Used to explicitly initialize the weak pointer with a null pointer
             inline WeakPtr(int) : pointer_(0), base_(0), callback_(0)
             {
             }
 
+            /// Constructor: Initializes the weak pointer with a pointer to an object.
             inline WeakPtr(T* pointer) : pointer_(pointer), base_(pointer), callback_(0)
             {
@@ -61,4 +118,5 @@
             }
 
+            /// Copy-constructor
             inline WeakPtr(const WeakPtr& other) : pointer_(other.pointer_), base_(other.base_), callback_(0)
             {
@@ -67,4 +125,5 @@
             }
 
+            /// Copy-constructor for weak pointers to objects of another class.
             template <class O>
             inline WeakPtr(const WeakPtr<O>& other) : pointer_(other.get()), base_(other.base_), callback_(0)
@@ -74,4 +133,5 @@
             }
 
+            /// Destructor
             inline ~WeakPtr()
             {
@@ -81,4 +141,5 @@
             }
 
+            /// Used to assign a null pointer.
             inline WeakPtr& operator=(int)
             {
@@ -87,4 +148,5 @@
             }
 
+            /// Assigns a new pointer.
             inline WeakPtr& operator=(T* pointer)
             {
@@ -93,4 +155,5 @@
             }
 
+            /// Assigns the wrapped pointer of another WeakPtr.
             inline WeakPtr& operator=(const WeakPtr& other)
             {
@@ -99,4 +162,5 @@
             }
 
+            /// Assigns the wrapped pointer of a WeakPtr of another class
             template <class O>
             inline WeakPtr& operator=(const WeakPtr<O>& other)
@@ -106,4 +170,5 @@
             }
 
+            /// Returns the wrapped pointer as @c T*
             inline T* get() const
             {
@@ -111,4 +176,5 @@
             }
 
+            /// Returns the wrapped pointer as @c OrxonoxClass*
             inline OrxonoxClass* getBase() const
             {
@@ -116,4 +182,5 @@
             }
 
+            /// Implicitly converts the WeakPtr to a pointer of type @c T*
             inline operator T*() const
             {
@@ -121,4 +188,5 @@
             }
 
+            /// Overloaded operator, returns a pointer to the stored object.
             inline T* operator->() const
             {
@@ -127,4 +195,5 @@
             }
 
+            /// Overloaded operator, returns a reference to the stored object.
             inline T& operator*() const
             {
@@ -133,4 +202,5 @@
             }
 
+            /// Returns true if the wrapped pointer is NULL.
             inline bool operator!() const
             {
@@ -138,4 +208,5 @@
             }
 
+            /// Swaps the contents of two weak pointers.
             inline void swap(WeakPtr& other)
             {
@@ -162,4 +233,5 @@
             }
 
+            /// Resets the weak pointer (equivalent to assigning a NULL pointer).
             inline void reset()
             {
@@ -167,4 +239,5 @@
             }
 
+            /// Registers a callback that will be executed if the stored object is destroyed.
             inline void setCallback(const FunctorPtr& callback)
             {
@@ -172,4 +245,5 @@
             }
 
+            /// Returns the registered callback.
             inline const FunctorPtr& getCallback() const
             {
@@ -178,4 +252,5 @@
 
         private:
+            /// Will be called by OrxonoxClass::~OrxonoxClass() if the stored object is deleted. Resets the wrapped pointer and executes the callback.
             inline void objectDeleted()
             {
@@ -186,9 +261,10 @@
             }
 
-            T* pointer_;
-            OrxonoxClass* base_;
-            FunctorPtr callback_;
+            T* pointer_;            ///< The wrapped pointer to an object of type @a T
+            OrxonoxClass* base_;    ///< The wrapped pointer, casted up to OrxonoxClass (this is needed because with just a T* pointer, WeakPtr couln't be used with forward declarations)
+            FunctorPtr callback_;   ///< This callback will be executed if the stored object is deleted
     };
 
+    /// Swaps the contents of two weak pointers.
     template <class T>
     void swap(WeakPtr<T>& a, WeakPtr<T>& b)
@@ -197,4 +273,5 @@
     }
 
+    /// Uses a static_cast to cast a pointer of type U* to a pointer of type T* and returns it in a new WeakPtr<T>.
     template <class T, class U>
     WeakPtr<T> static_pointer_cast(const WeakPtr<U>& p)
@@ -203,4 +280,5 @@
     }
 
+    /// Uses a const_cast to cast a pointer of type U* to a pointer of type T* and returns it in a new WeakPtr<T>.
     template <class T, class U>
     WeakPtr<T> const_pointer_cast(const WeakPtr<U>& p)
@@ -209,4 +287,5 @@
     }
 
+    /// Uses a dynamic_cast to cast a pointer of type U* to a pointer of type T* and returns it in a new WeakPtr<T>.
     template <class T, class U>
     WeakPtr<T> dynamic_pointer_cast(const WeakPtr<U>& p)
Index: code/trunk/src/libraries/core/WindowEventListener.h
===================================================================
--- code/trunk/src/libraries/core/WindowEventListener.h	(revision 7380)
+++ code/trunk/src/libraries/core/WindowEventListener.h	(revision 7401)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Graphics
+*/
 
 #ifndef _WindowEventListener_H__
Index: code/trunk/src/libraries/core/XMLFile.h
===================================================================
--- code/trunk/src/libraries/core/XMLFile.h	(revision 7380)
+++ code/trunk/src/libraries/core/XMLFile.h	(revision 7401)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup XML XMLPort
+*/
 
 #ifndef _XMLFile_H__
Index: code/trunk/src/libraries/core/XMLNameListener.h
===================================================================
--- code/trunk/src/libraries/core/XMLNameListener.h	(revision 7380)
+++ code/trunk/src/libraries/core/XMLNameListener.h	(revision 7401)
@@ -27,4 +27,9 @@
  */
 
+/**
+    @file
+    @ingroup XML XMLPort
+*/
+
 #ifndef _XMLNameListener_H__
 #define _XMLNameListener_H__
